'''
    Funny or Die Add-on

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
'''

from resources.lib import Addon, source
import sys, os, urllib, urllib2
import json
import xbmc, xbmcgui, xbmcplugin, xbmcaddon

import liveresolver

addon = xbmcaddon.Addon()
addonname = addon.getAddonInfo('name')
addonid = addon.getAddonInfo('id')
plugin_path = xbmcaddon.Addon(id=addonid).getAddonInfo('path')

Addon.plugin_url = sys.argv[0]
Addon.plugin_handle = int(sys.argv[1])
Addon.plugin_queries = Addon.parse_query(sys.argv[2][1:])

dlg = xbmcgui.Dialog()

Addon.log('plugin url: ' + Addon.plugin_url)
Addon.log('plugin queries: ' + str(Addon.plugin_queries))
Addon.log('plugin handle: ' + str(Addon.plugin_handle)) 

mode = Addon.plugin_queries['mode']

if mode == 'main':
    try:
        channels = source.Source().build_main()
        if channels:
            for c in sorted(channels):
                Addon.add_directory({'mode': c['title']}, c['title'], img = c['img'])
    except:
        dlg.ok(Addon.get_string(5000), Addon.get_string(8000))
        exit()

def show_streams(title, etag):
    if mode == title:
        streams = source.Source().get_streams(etag)
        if streams:
            for c in streams:
                stream = c['stream'];
                videoId = c['videoId'];
                rURL = Addon.plugin_url + "?etag=" + etag + "&videoId=" + videoId + "&mode=play&rand=" + Addon.random_generator()
                logo = c['img']
                Addon.add_video_item(rURL, {'title': stream}, img=logo)

    elif mode=='play':
        videoId = Addon.plugin_queries['videoId']
        etag = Addon.plugin_queries['etag']
        stream_status = source.Source()._get_json('/check.php', {'id': videoId})['status']
        if stream_status == 'true':
            streams = []
            streams = source.Source().get_link(etag)
            if streams:
                for c in sorted(streams):
                    if c['id'] == videoId:
                        url = c['url']
                        stream_url = liveresolver.resolve(url)
                        item = xbmcgui.ListItem(path=stream_url)
                        xbmcplugin.setResolvedUrl(int(sys.argv[1]), True, item)
        else:
            dlg.ok(Addon.get_string(5000), '"' + title + '"' + " " + Addon.get_string(7000))

if mode != 'main':
    streams = source.Source().build_main()
    if streams:
        for c in streams:
            show_streams(c['title'], c['etag'])

Addon.end_of_directory()
